Bug 506381 - Flawed logrotate method
Flawed logrotate method
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: httpd (Show other bugs)
11
All Linux
low Severity high
: ---
: ---
Assigned To: Joe Orton
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-06-16 22:20 EDT by JW
Modified: 2010-06-28 09:04 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-06-28 09:04:47 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description JW 2009-06-16 22:20:14 EDT
Description of problem:
The installed logrotate entry (/etc/logrotate.d/httpd) can result in httpd writing to deleted log file with subsequent log entries being lost.


Version-Release number of selected component (if applicable):
httpd-2.2.11-8

How reproducible:
Difficult because can depend on how busy httpd is.

Steps to Reproduce:
1. wait for logrotate to rotate httpd log files
2. run: lsof -p`cat /var/run/httpd.pid`
  
Actual results:
Depending on unknown circumstances one might observer that httpd ends up still writing to deleted log files.  Consequently log entries will be lost. This is especially true if logrotate compresses the rotated files.

Expected results:
No log entries should be lost.

Additional info:
If one reads the apache manual (logs.html#rotation) one will learn that the proper way to rotate logs is to rename the logs, invoke "apachectl graceful" then sleep for a while, then compress the files. So ideally the logrotate script should appear something like this:

/var/log/http/*log {
    missingok
    notifempty
    sharedscripts
    delaycompress
    postrotate
        /sbin/service httpd graceful
    endscript
}

The important line is the "delaycompress".  This means that the active log file will be renamed (and httpd might continue writing to it for some time) but no log entries will be lost.  The renamed log file will get compressed next invocation of logrotate by which time httpd will have completely switched over to the new log files.

Additionally it would be nice if the logrotate entry didn't use 'kill -HUP' but instead used existing /etc/rc.d/init.d/httpd script so that arcane application control methods are all confined to one place. However using "apache -k" or apachectl are not half as bad as using kill (and depending on assumptions about where httpd's pid can be located).
Comment 1 Joe Orton 2009-08-18 07:55:53 EDT
Thanks a lot for the report and analysis!  I've committed this change.
Comment 2 Bug Zapper 2010-04-27 11:00:13 EDT
This message is a reminder that Fedora 11 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 11.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '11'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 11's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 11 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 3 Bug Zapper 2010-06-28 09:04:47 EDT
Fedora 11 changed to end-of-life (EOL) status on 2010-06-25. Fedora 11 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.